import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class PointOfView extends PApplet {// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

float    SCENE_RADIUS              = 200;
int      WIDTH                     = 800;
int      HEIGHT                    = 420;
int      DEPTH                     = 420;
float    BOX_SIZE                  = 7;
float    BOX_RADIUS                = 30;
float    GRID_SPACING              = -2;
float    ROTATION_SPEED_APPROACH   = 10;
float    ROTATION_SPEED            = 1;
float    CURSOR_OFFSET             = 0;
int      CHARACTER_WIDTH           = 8;
int      CHARACTER_HEIGHT          = 8;
float    FILL_RATE                 = 120;
float    CAMERA_DISTANCE           = 4;
float    CAMERA_FOV                = 3;
float    CAMERA_HEIGHT             = 0;
int      NUMBER_OF_BOXES           = 300;
float    SNAP_RADIUS               = 300;
float    SNAP_SPEED                = 0.1f;

Scene          mainScene;
Camera         mainCamera;
Renderer       mainRenderer;
CharacterSet   characterSet;

public void setup
() 
{  
  mainScene = new Scene();
  mainCamera = new Camera();
  mainRenderer = new Renderer();
  characterSet = new CharacterSet();
}

public void draw
()
{
  mainScene.tick();
  mainCamera.tick();
  mainRenderer.draw( mainScene, mainCamera );
}

public void keyPressed
()
{
  if ( keyCode == UP )
  {
    mainCamera.moveInAndOut( 0.95f );
  }
  else if ( keyCode == DOWN )
  {
    mainCamera.moveInAndOut( 1.05f );
  }
  else if ( keyCode == RIGHT )
  {
    mainCamera.rotateRight();
  }
  else if ( keyCode == LEFT )
  {
    mainCamera.rotateLeft();
  }
  else
  {
    mainScene.setCharacter( characterSet.getCharacter( key ), mainCamera );
  }
}

public Vector findPositionOnSphere
( Box[] boxes )
{
  while ( true ) 
  {
    float x1 = random( -1, 1 );
    float x2 = random( -1, 1 );
        
    if ( x1 * x1 + x2 * x2 >= 1 )
    {
      continue;
    }
        
    float r = SCENE_RADIUS;
    float x = 2 * r * x1 * sqrt( 1 - x1 * x1 - x2 * x2 );
    float y = 2 * r * x2 * sqrt( 1 - x1 * x1 - x2 * x2 );
    float z = r * ( 1 - 2 * ( x1 * x1 + x2 * x2 ) );
    Vector position = new Vector( x, y, z );
        
    if ( isTooCloseToOtherBoxes( position, boxes ) )
    {
      continue;
    }
        
    return position;
  }
}
  
public boolean isTooCloseToOtherBoxes
( Vector position,
  Box[] boxes)
{
  Vector diff;
   
  for ( int i=0; i<boxes.length; i++ )
  {
    if ( boxes[i] != null )
    {
      diff = boxes[i].position.sub( position );
        
      if ( diff.length2() <= BOX_RADIUS * BOX_RADIUS )
      {
        return true;
      }
    }
  }
    
  return false;
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Box
{
  Vector position;
  Vector orientation;
  boolean active;
  
  Box
  ()
  {
    position = new Vector();
    active = false;
  }
  
  Box
  ( Vector position )
  {
    this.position = position;
    active = false;
  }
  
  Box
  ( Vector position,
    boolean active )
  {
    this.position = position;
    this.active = active;
  }
  
  public float getRotationX
  ()
  {
    return 0;
  }
  
  public float getRotationY
  ()
  {
    return 0;
  }
  
  public float getRotationZ
  ()
  {
    return 0;
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Camera
{
  Vector cursorPosition;
  Vector cameraPosition;
  Vector[] nicePoints;
  
  Camera
  ()
  {
    cursorPosition = new Vector( WIDTH/2, HEIGHT/2, 0 );
    cameraPosition = new Vector( 0, 50, SCENE_RADIUS * CAMERA_DISTANCE );
    
    nicePoints = new Vector[4];
    nicePoints[0] = new Vector( 0, -CAMERA_HEIGHT, SCENE_RADIUS * CAMERA_DISTANCE );
    nicePoints[1] = new Vector( SCENE_RADIUS * CAMERA_DISTANCE, -CAMERA_HEIGHT, 0 );
    nicePoints[2] = new Vector( 0, -CAMERA_HEIGHT, -SCENE_RADIUS * CAMERA_DISTANCE );
    nicePoints[3] = new Vector( -SCENE_RADIUS * CAMERA_DISTANCE, -CAMERA_HEIGHT, 0 );
  }
  
  public void tick
  ()
  {
    float diffX;
    float diffY;
    
    float rotationX;
    float rotationY;
    
    Vector up;
    Vector cross;

    if ( !mousePressed )
    {
      Vector diff = findClosestNicePoint().sub( cameraPosition );
      
      if ( diff.length2() < SNAP_RADIUS * SNAP_RADIUS )
      {
        cameraPosition = cameraPosition.add( diff.mul( SNAP_SPEED ) );
      }
    }
    
    if ( mousePressed )
    {
      diffX = mouseX - cursorPosition.x;
      diffY = mouseY - cursorPosition.y;
    }
    else
    {
      diffX = WIDTH/2 + CURSOR_OFFSET - cursorPosition.x;
      diffY = HEIGHT/2 - cursorPosition.y;
    }
      
    cursorPosition.x += diffX * ROTATION_SPEED_APPROACH / 100;
    cursorPosition.y += diffY * ROTATION_SPEED_APPROACH / 100;

    rotationX = ( cursorPosition.x - WIDTH/2 ) * ROTATION_SPEED / 5000;
    rotationY = ( cursorPosition.y - HEIGHT/2 ) * ROTATION_SPEED / 5000;
    
    up = new Vector( 0, 1, 0 );
    cameraPosition = cameraPosition.arbitraryRotate( up, -rotationX );
    
    // Disable y rotation for now...
    // cross = up.cross( cameraPosition );
    // cameraPosition = cameraPosition.arbitraryRotate( cross, -rotationY );
  }
  
  public int findClosestNicePointIndex()
  {
    Vector diff = nicePoints[0].sub( cameraPosition );
    float closestLength = diff.length();
    int index = 0;
    
    for ( int i=1; i<4; i++ )
    {
      diff = nicePoints[i].sub( cameraPosition );
      
      if ( diff.length() < closestLength )
      {
        closestLength = diff.length();
        index = i;
      }
    }
    
    return index;
  }
  
  public Vector findClosestNicePoint
  ()
  {
    return nicePoints[ findClosestNicePointIndex() ];
  }
  
  public void moveInAndOut
  ( float k )
  {
    cameraPosition = cameraPosition.mul( k );
    SNAP_RADIUS *= k;
    
    for ( int i=0; i<nicePoints.length; i++ )
    {
      nicePoints[i] = nicePoints[i].mul( k );
    }
  }
  
  public void rotateRight
  ()
  {
    Vector up = new Vector( 0, 1, 0 );
    cameraPosition = cameraPosition.arbitraryRotate( up, radians( 85 ) );
  }
  
  public void rotateLeft
  ()
  {
    Vector up = new Vector( 0, 1, 0 );
    cameraPosition = cameraPosition.arbitraryRotate( up, radians( -85 ) );
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Character
{
  boolean[][]  map;
  
  Character
  ()
  {    
    map = new boolean[ CHARACTER_WIDTH ][ CHARACTER_HEIGHT ];
  }
  
  Character
  ( String name )
  {
    map = new boolean[ CHARACTER_WIDTH ][ CHARACTER_HEIGHT ];
    String[] contents = loadStrings( "characters/" + name + ".char" );

    for ( int i=0; i<CHARACTER_HEIGHT; i++ )
    {
      for ( int j=0; j<CHARACTER_WIDTH; j++ )
      {
        map[i][j] = ( String.valueOf( contents[i].charAt(2*j) ).equals("#") );
      }
    }
  }
  
  public Character reverse
  ()
  {
    Character r = new Character();
    
    for ( int i=0; i<CHARACTER_HEIGHT; i++ )
    {
      for ( int j=0; j<CHARACTER_WIDTH; j++ )
      {
        r.map[i][j] = map[i][CHARACTER_WIDTH - j - 1];
      }
    }
    
    return r;
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class CharacterSet
{
  HashMap characterMap;
  
  CharacterSet
  ()
  {
    String[] characterList = loadStrings( "characters/characters.char" );
    
    characterMap = new HashMap();
    
    for ( int i=0; i<characterList.length; i++ )
    {
      Character character = new Character( characterList[i] );
      characterMap.put( characterList[i], character );
    }
  }
  
  public Character getCharacter
  ( char c )
  {
    String key = String.valueOf( c );
    
    if ( characterMap.containsKey( key ) )
    {
      return ( Character) characterMap.get( key );
    }
    else
    {
      return ( Character) characterMap.get( String.valueOf('$') );
    }
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Renderer
{  
  Renderer
  ()
  {
    size( WIDTH, HEIGHT, P3D );
    noStroke();
  }
  
  public void draw
  ( Scene           scene,
    Camera          camera )
  {
    background( 255 );

    pointLight( 100, 100, 100, camera.cameraPosition.x, camera.cameraPosition.y, camera.cameraPosition.z );
    pointLight( 100, 100, 100, 0, 0, 0 );
    translate( WIDTH/2, HEIGHT/2, -DEPTH/2 );
    
    float fov = PI/10.0f;
    float cameraZ = (height/2.0f) / tan(PI * fov / 360.0f);
    perspective(fov, PApplet.parseFloat(width)/PApplet.parseFloat(height), cameraZ/10.0f, cameraZ*10.0f);
    
    camera( camera.cameraPosition.x, camera.cameraPosition.y, camera.cameraPosition.z, 0, 0, 0, 0, 1, 0 );
    
    if ( scene.boxes != null )
    {
      for ( int i=0; i<scene.boxes.length; i++ ) 
      {
        if ( scene.boxes[i] == null)
        {
          break;
        }
        
        pushMatrix();
        translate( scene.boxes[i].position.x, scene.boxes[i].position.y, scene.boxes[i].position.z );
        rotateX( scene.boxes[i].getRotationX() );
        rotateY( scene.boxes[i].getRotationY() );
        rotateZ( scene.boxes[i].getRotationZ() );
        drawBox( BOX_SIZE, BOX_SIZE, BOX_SIZE, scene.boxes[i].active );
        popMatrix();  
      }
    }
  }
  
  public void drawBox
  ( float w, 
    float h, 
    float d,
    boolean active )
  {  
    w = 2 * w;
    h = 2 * h;
    d = 2 * d;
    
    if ( !active )
    {
      fill( 100, 100, 100, 10 );
      box( w, h, d );
    }
    else
    {
      fill( 153, 153, 136 );
      box( w, h, d );
    }
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Scene
{
  Box[] boxes;
  Box[] idealBoxes;
  
  SceneSolver solver;
  SceneAnimator animator;
  
  Scene
  ()
  {
    boxes = new Box[ NUMBER_OF_BOXES ];
    
    solver = new SceneSolver();
    animator = new SceneAnimator();
    
    for ( int i=0; i<NUMBER_OF_BOXES; i++ )
    {
      boxes[i] = new Box( findPositionOnSphere( boxes ) ); 
    }    
    
    idealBoxes = solver.solve( boxes );
  }
  
  public void tick
  ()
  {
    animateBoxes();
  }
  
  public void animateBoxes
  ()
  {
    boxes = animator.animate( boxes, idealBoxes );
  }
  
  public void setCharacter
  ( Character character,
    Camera camera )
  {
    solver.setCharacter( character, camera.findClosestNicePointIndex() );
    idealBoxes = solver.solve( boxes );
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class SceneAnimator
{
  long frameStart;
  boolean animating;
  
  SceneAnimator()
  {
    animating = false;
  }
  
  public Box[] animate
  ( Box[] currentBoxes,
    Box[] idealBoxes )
  {
    Box[] r = new Box[ currentBoxes.length ];
    
    Vector currentPosition;
    Vector idealPosition;
    Vector diff;
    float diffLength2;
    float max;
    boolean perhapsHasStopped = true;
    
    for ( int i=0; i<currentBoxes.length; i++ )
    {
        currentPosition = currentBoxes[i].position;
        idealPosition = idealBoxes[i].position;
        diff = idealPosition.sub( currentPosition );
        diffLength2 = diff.length2();
        
        if ( diff.length2() > BOX_SIZE * BOX_SIZE )
        {
          if ( !animating )
          {
            animating = true;
            frameStart = frameCount;
          }
          
          perhapsHasStopped &= false;
        }
        
        if ( frameCount - frameStart > i * frameRate / FILL_RATE )
        {
          if ( diff.length() > BOX_SIZE / 5 )
          {
            r[i] = new Box( currentPosition.add( diff.mul( 0.05f ) ) );
          }
          else
          {
            r[i] = new Box( currentPosition.add( diff ) );
          }
          
          r[i].active = idealBoxes[i].active;
        }
        else
        {
          r[i] = new Box( currentPosition );
          r[i].active = currentBoxes[i].active;
        }
    }
    
    if ( perhapsHasStopped )
    {
      animating = false;
    }
    
    return r;
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class ImportantBoxCoordinate
{
  int i;
  int j;
  int k;
  
  ImportantBoxCoordinate( int i, int j, int k )
  {
    this.i = i;
    this.j = j;
    this.k = k;
  }
}

class SceneSolver
{
  Character[] characters;
  
  SceneSolver
  ()
  {
    characters = new Character[2];
    characters[0] = new Character( "a" );
    characters[1] = new Character( "e" );
  }
  
  public void setCharacter
  ( Character character,
    int axisIdentifier )
  {
    if ( axisIdentifier == 0 || axisIdentifier == 1 )
    {
      characters[ axisIdentifier % 2 ] = character;
    }
    else
    {
      characters[ axisIdentifier % 2 ] = character.reverse();
    }
  }
  
  public Box[] solve
  ( Box[] currentBoxes )
  {
    boolean[][][] solutionSpace;
    ArrayList importantBoxes;
    Box[] r = new Box[ currentBoxes.length ];
    
    solutionSpace = new boolean[ CHARACTER_WIDTH ][ CHARACTER_HEIGHT ][ CHARACTER_WIDTH ];
    
    for ( int i=0; i<CHARACTER_HEIGHT; i++ )
    {
      for ( int j=0; j<CHARACTER_WIDTH; j++ )
      {
        for ( int k=0; k<CHARACTER_WIDTH; k++ )
        {
          solutionSpace[j][i][k] = getCharacterValue( 0, j, i ) && getCharacterValue( 1, j, CHARACTER_WIDTH - k - 1 );
        }
      }
    }
    
    importantBoxes = new ArrayList();
    
    for ( int i=0; i<CHARACTER_HEIGHT; i++ )
    {
      for ( int j=0; j<CHARACTER_WIDTH; j++ )
      {
        for ( int k=0; k<CHARACTER_WIDTH; k++ )
        {
          if ( solutionSpace[j][i][k] )
          {
            ImportantBoxCoordinate coordinate = new ImportantBoxCoordinate( i, j, k );
            importantBoxes.add( coordinate );
          }
        }
      }
    }
    
    for ( int i=0; i<currentBoxes.length; i++ )
    {
      if ( i < importantBoxes.size() )
      {
        ImportantBoxCoordinate coordinate = (ImportantBoxCoordinate) importantBoxes.get(i); 
      
        r[i] = new Box();
        r[i].active = true;
        r[i].position.x = ( coordinate.i - CHARACTER_WIDTH/2 ) * ( 2 * BOX_SIZE + GRID_SPACING ) + GRID_SPACING/2;
        r[i].position.y = ( coordinate.j - CHARACTER_HEIGHT/2 ) * ( 2 * BOX_SIZE + GRID_SPACING ) + GRID_SPACING/2;
        r[i].position.z = ( coordinate.k - CHARACTER_WIDTH/2 ) * ( 2 * BOX_SIZE + GRID_SPACING ) + GRID_SPACING/2;
      }
      else
      {
        if ( currentBoxes[i].position.length() > SCENE_RADIUS * 0.9f )
        {
          r[i] = new Box( currentBoxes[i].position );
        }
        else
        {
          r[i] = new Box( findPositionOnSphere( r ) );
        }
      }
    }
    
    return r;
  }
  
  public boolean getCharacterValue
  ( int characterIdentifier,
    int i,
    int j )
  {
    if ( characters[ characterIdentifier ] != null )
    {
      return characters[ characterIdentifier ].map[ i ][ j ];
    }
    
    return true;
  }
}

// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Vector
{
  float a;
  float b;
  float c;
  
  float x;
  float y;
  float z;
  
  Vector
  ()
  {
    a = x = 0;
    b = y = 0;
    c = z = 0;
  }
  
  Vector
  ( float a,
    float b,
    float c )
  {
    this.a = this.x = a;
    this.b = this.y = b;
    this.c = this.z = c;
  }
  
  public void setA
  ( float x )
  {
    this.a = this.x = x;
  }
  
  public void setB
  ( float y )
  {
    this.b = this.y = y;
  }
  
  public void setC
  ( float z )
  {
    this.c = this.z = z;
  }
  
  public void setX
  ( float x )
  {
    this.a = this.x = x;
  }
  
  public void setY
  ( float y )
  {
    this.b = this.y = y;
  }
  
  public void setZ
  ( float z )
  {
    this.c = this.z = z;
  }
  
  public void set
  ( Vector v )
  {
    this.setA( v.a );
    this.setB( v.b );
  }
  
  public void set
  ( float x,
    float y,
    float z )
  {
    this.setA( x );
    this.setB( y );
    this.setC( z );
  }
  
  public float length
  ()
  {
    return sqrt( x * x + y * y + z * z );
  }
  
  public float length2
  ()
  {
    return x * x + y * y + z * z;
  }
  
  public Vector normalise
  ()
  {
    Vector r = new Vector();
    float length = length();
    
    r.setA( x / length );
    r.setB( y / length );
    r.setC( z / length );
    
    return r;
  }
  
  public Vector cross
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.y * v.z - this.z * v.y,
           this.z * v.x - this.x * v.z,
           this.x * v.y - this.y * v.x );
    
    return r;
  }
  
  public Vector mul
  ( float k )
  {
    Vector r = new Vector();
    
    r.set( this.x * k,
           this.y * k,
           this.z * k );
           
    return r;
  }
  
  public Vector add
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.x + v.x,
           this.y + v.y,
           this.z + v.z );
           
    return r;
  }
  
  public Vector sub
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.x - v.x,
           this.y - v.y,
           this.z - v.z );
           
    return r;
  }
  
  public Vector arbitraryRotate
  ( Vector a,
    float theta )
  {
    Vector r = new Vector();    
    float costheta = cos(theta);
    float sintheta = sin(theta);
    
    a = a.normalise();

    r.x += (costheta + (1 - costheta) * a.x * a.x) * this.x;
    r.x += ((1 - costheta) * a.x * a.y - a.z * sintheta) * this.y;
    r.x += ((1 - costheta) * a.x * a.z + a.y * sintheta) * this.z;

    r.y += ((1 - costheta) * a.x * a.y + a.z * sintheta) * this.x;
    r.y += (costheta + (1 - costheta) * a.y * a.y) * this.y;
    r.y += ((1 - costheta) * a.y * a.z - a.x * sintheta) * this.z;

    r.z += ((1 - costheta) * a.x * a.z - a.y * sintheta) * this.x;
    r.z += ((1 - costheta) * a.y * a.z + a.x * sintheta) * this.y;
    r.z += (costheta + (1 - costheta) * a.z * a.z) * this.z;
    
    return r;
  }
}

  static public void main(String args[]) {     PApplet.main(new String[] { "PointOfView" });  }}