// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Renderer
{  
  Renderer
  ()
  {
    size( WIDTH, HEIGHT, P3D );
    noStroke();
  }
  
  void draw
  ( Scene           scene,
    Camera          camera )
  {
    background( 255 );

    pointLight( 100, 100, 100, camera.cameraPosition.x, camera.cameraPosition.y, camera.cameraPosition.z );
    pointLight( 100, 100, 100, 0, 0, 0 );
    translate( WIDTH/2, HEIGHT/2, -DEPTH/2 );
    
    float fov = PI/10.0;
    float cameraZ = (height/2.0) / tan(PI * fov / 360.0);
    perspective(fov, float(width)/float(height), cameraZ/10.0, cameraZ*10.0);
    
    camera( camera.cameraPosition.x, camera.cameraPosition.y, camera.cameraPosition.z, 0, 0, 0, 0, 1, 0 );
    
    if ( scene.boxes != null )
    {
      for ( int i=0; i<scene.boxes.length; i++ ) 
      {
        if ( scene.boxes[i] == null)
        {
          break;
        }
        
        pushMatrix();
        translate( scene.boxes[i].position.x, scene.boxes[i].position.y, scene.boxes[i].position.z );
        rotateX( scene.boxes[i].getRotationX() );
        rotateY( scene.boxes[i].getRotationY() );
        rotateZ( scene.boxes[i].getRotationZ() );
        drawBox( BOX_SIZE, BOX_SIZE, BOX_SIZE, scene.boxes[i].active );
        popMatrix();  
      }
    }
  }
  
  void drawBox
  ( float w, 
    float h, 
    float d,
    boolean active )
  {  
    w = 2 * w;
    h = 2 * h;
    d = 2 * d;
    
    if ( !active )
    {
      fill( 100, 100, 100, 10 );
      box( w, h, d );
    }
    else
    {
      fill( 153, 153, 136 );
      box( w, h, d );
    }
  }
}
