// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Scene
{
  Box[] boxes;
  Box[] idealBoxes;
  
  SceneSolver solver;
  SceneAnimator animator;
  
  Scene
  ()
  {
    boxes = new Box[ NUMBER_OF_BOXES ];
    
    solver = new SceneSolver();
    animator = new SceneAnimator();
    
    for ( int i=0; i<NUMBER_OF_BOXES; i++ )
    {
      boxes[i] = new Box( findPositionOnSphere( boxes ) ); 
    }    
    
    idealBoxes = solver.solve( boxes );
  }
  
  void tick
  ()
  {
    animateBoxes();
  }
  
  void animateBoxes
  ()
  {
    boxes = animator.animate( boxes, idealBoxes );
  }
  
  void setCharacter
  ( Character character,
    Camera camera )
  {
    solver.setCharacter( character, camera.findClosestNicePointIndex() );
    idealBoxes = solver.solve( boxes );
  }
}
