// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments... I never thought this would end up
// online. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class SceneAnimator
{
  long frameStart;
  boolean animating;
  
  SceneAnimator()
  {
    animating = false;
  }
  
  Box[] animate
  ( Box[] currentBoxes,
    Box[] idealBoxes )
  {
    Box[] r = new Box[ currentBoxes.length ];
    
    Vector currentPosition;
    Vector idealPosition;
    Vector diff;
    float diffLength2;
    float max;
    boolean perhapsHasStopped = true;
    
    for ( int i=0; i<currentBoxes.length; i++ )
    {
        currentPosition = currentBoxes[i].position;
        idealPosition = idealBoxes[i].position;
        diff = idealPosition.sub( currentPosition );
        diffLength2 = diff.length2();
        
        if ( diff.length2() > BOX_SIZE * BOX_SIZE )
        {
          if ( !animating )
          {
            animating = true;
            frameStart = frameCount;
          }
          
          perhapsHasStopped &= false;
        }
        
        if ( frameCount - frameStart > i * frameRate / FILL_RATE )
        {
          if ( diff.length() > BOX_SIZE / 5 )
          {
            r[i] = new Box( currentPosition.add( diff.mul( 0.05 ) ) );
          }
          else
          {
            r[i] = new Box( currentPosition.add( diff ) );
          }
          
          r[i].active = idealBoxes[i].active;
        }
        else
        {
          r[i] = new Box( currentPosition );
          r[i].active = currentBoxes[i].active;
        }
    }
    
    if ( perhapsHasStopped )
    {
      animating = false;
    }
    
    return r;
  }
}
